# Generated by Django 2.2 on 2020-11-23 13:38

from django.conf import settings
import django.contrib.postgres.fields.jsonb
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import thx.cron.validators
from ..utils import get_command


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Job',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('status', models.IntegerField(choices=[(-2, 'draft'), (0, 'to run'), (-1, 'running'), (1, 'completed')], default=0, verbose_name='status')),
                ('year', models.PositiveIntegerField(blank=True, null=True, validators=[thx.cron.validators.validate_year], verbose_name='year')),
                ('month', models.PositiveIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(1), django.core.validators.MaxValueValidator(12)], verbose_name='month')),
                ('day', models.PositiveIntegerField(blank=True, null=True, verbose_name='day')),
                ('hour', models.PositiveIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(23)], verbose_name='hour')),
                ('minute', models.PositiveIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(59)], verbose_name='minute')),
                ('name', models.CharField(max_length=255, verbose_name='name')),
                ('command', models.CharField(choices=get_command, max_length=255, verbose_name='command')),
                ('parameters', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, verbose_name='parameters')),
                ('is_una_tantum', models.BooleanField(default=False, verbose_name='is una tantum')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='cron_job_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='cron_job_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
            ],
            options={
                'verbose_name': 'job',
                'verbose_name_plural': 'jobs',
                'ordering': ('ordering', 'name'),
                'permissions': (('list_job', 'Can list job'), ('detail_job', 'Can detail job'), ('disable_job', 'Can disable job')),
            },
        ),
        migrations.CreateModel(
            name='JobLog',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('elaboration_time', models.DurationField(blank=True, null=True, verbose_name='elaboration time')),
                ('elaboration_results', django.contrib.postgres.fields.jsonb.JSONField(verbose_name='elaboration results')),
                ('is_valid', models.NullBooleanField(verbose_name='is valid')),
                ('job', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='job_elaborations', to='cron.Job', verbose_name='job')),
            ],
            options={
                'verbose_name': 'job log',
                'verbose_name_plural': 'job logs',
                'ordering': ('-date_create',),
                'permissions': (('list_joblog', 'Can list job log'), ('detail_joblog', 'Can detail job log'), ('disable_joblog', 'Can disable job log')),
            },
        ),
    ]
